\documentclass[]{article}
\usepackage{bm}
\usepackage{graphicx}
\usepackage{float}
\usepackage{subcaption}
\usepackage{amsmath}

\newcommand\myatop[2]{\left[{{#1}\atop#2}\right]}
\newcommand\myabottom[2]{\left[{{#1}\abottom#2}\right]}
%
%opening
\title{IPPR Assignment 2}
\author{Marcus Ackerl, 01330813\\Gabriel Weissenbaeck, 01610048}
%
\begin{document}
%
\maketitle%

\section*{Task 6.1 Mean Shift derivation}
The first task was to derive the mean shift iteration, the update function for $x$, for the K-means clustering approximation of the denoising model.
In detail, the derivation of the modified algorithm,
$$\hat{x}=\underset{x}{\arg\max}\Big[
\exp\Big(-\frac{1}{2\sigma^2}||y-x||^2\Big)
\sum_{i=1}^{N_c}w_i\exp\Big(-\frac{1}{2}\Big|\Big|\frac{Dx-c_i^{dct}}{h}\Big|\Big|^2\Big)
\Big]$$
should be done with respect to x, to arrive at the update function:
$$x\leftarrow\Big(\frac{1}{h^2}D^TD+\frac{1}{\sigma^2}I\Big)^{-1}
\Big(\frac{1}{h^2}D^T\frac{\sum_{i=1}^{N_c}c_i^{dct}\tilde{w}_i(x)}{\sum_{i=1}^{N_c}\tilde{w}_i(x)}+\frac{1}{\sigma^2}y\Big)
$$
Where $\tilde{w}_i(x) = w_i\exp\Big(-\frac{1}{2h^2}||Dx-c_i^{dct}||^2\Big)$
Furthermore, $\{(c_i^{dct}, w_i)\}_{i=1}^{N_c}$ denotes the $N_c$ cluster centers and weights of the K-means approximation for $N_c$ clusters, $D$ is a Matrix representing the 2D, mean-free DCT, $h$ is the bandwitdh of the KDE and $\sigma$ denotes the noise level.\\
\\
The bandwith $h$ of the KDE-approximation, influences the impact of the points depending on the distance. A small bandwitdh leads to a steep curve of the weight with respect to distance, so a small distance will be weighted strong, while a grad distance will have very little impact. A large bandwitdh inverses this behavior, as a small distance does not lead to a substantially higher weighting, whereas more samples or samples with a greater distance still have an influence.\\
\\
The noise level $\sigma$ alters the influence of the noisy input $y$. As a high noise level renders the value of $y$ for the denoising worse, $\sigma$ alters also its impact to be smaller.\\ 
\\
To compute the derivation, the contents of the argmax function is derived with respect to x. As the maximum does not change if the logarithm is applied, this is done before:
$$
\exp\Big(-\frac{1}{2\sigma^2}||y-x||^2\Big)
\sum_{i=1}^{N_c}w_i\exp\Big(-\frac{1}{2}\Big|\Big|\frac{Dx-c_i^{dct}}{h}\Big|\Big|^2\Big)
$$
Insert $\tilde{w}_i$:
$$
\exp\Big(-\frac{1}{2\sigma^2}||y-x||^2\Big)
\sum_{i=1}^{N_c}\tilde{w}_i(x)
$$
Apply logarithm:
$$
-\frac{1}{2\sigma^2}||y-x||^2 
+\sum_{i=1}^{N_c} \ln(\tilde{w}_i(x))
$$
Derive with respect to $x$:
$$
\frac{1}{\sigma^2}(y-x) + 
\sum_{i=1}^{N_c}\Big[
\frac{1}{\tilde{w}_i(x)}
\cdot \underbrace{w_i\cdot\exp\Big(-\frac{1}{2h^2}||Dx-c_i^{dct}||^2\Big)}_{\tilde{w}_i(x)}
\cdot \Big(-\frac{1}{h^2}D^T(Dx-c_i^{dct})\Big)\Big]
$$
Rearrange and set to zero to compute the maximum with respect to $x$:
$$
-\frac{1}{\sigma^2}x + \frac{1}{\sigma^2}y+
\sum_{i=1}^{N_c}\Big[
-\frac{\tilde{w}_i(x)}{\tilde{w}_i(x)}\frac{1}{h^2}D^TDx
+\frac{\tilde{w}_i(x)}{\tilde{w}_i(x)}\frac{1}{h^2}c_i^{dct}D^T
\Big] = 0
$$
%$$
%\sum_{i=1}^{N_c}\Big[
%x\Big(-\frac{1}{\sigma^2}*I-\frac{1}{h^2}D^TD\Big) 
%+\frac{1}{h^2}D^T\frac{\tilde{w}_i(x)c_i^{dct}}{\tilde{w}_i(x)}
%+\frac{1}{\sigma^2}y
%\Big] = 0
%$$
%Now we bring the sums back to the fracion and rearrange the formula to compute the x update:
$$
x\Big(-\frac{1}{\sigma^2}I-\frac{1}{h^2}D^TD\Big) 
+\frac{1}{h^2}D^T\frac{\sum_{i=1}^{N_c}\tilde{w}_i(x)c_i^{dct}}{\sum_{i=1}^{N_c}\tilde{w}_i(x)}
+\frac{1}{\sigma^2}y
= 0
$$
$$
x +  
\Big(-\frac{1}{\sigma^2}I-\frac{1}{h^2}D^TD\Big)^{-1}
\Bigg(
\frac{1}{h^2}D^T\frac{\sum_{i=1}^{N_c}\tilde{w}_i(x)c_i^{dct}}{\sum_{i=1}^{N_c}\tilde{w}_i(x)}
+\frac{1}{\sigma^2}y
\Bigg) = 0
$$
$$ 
\Big(-\frac{1}{\sigma^2}I-\frac{1}{h^2}D^TD\Big)^{-1}
\Bigg(
\frac{1}{h^2}D^T\frac{\sum_{i=1}^{N_c}\tilde{w}_i(x)c_i^{dct}}{\sum_{i=1}^{N_c}\tilde{w}_i(x)}
+\frac{1}{\sigma^2}y
\Bigg) = -x
$$
Finally, we multiply with $-1$ to arrive at the desired result:
$$
x = 
\Big(\frac{1}{\sigma^2}I+\frac{1}{h^2}D^TD\Big)^{-1}
\Bigg(
\frac{1}{h^2}D^T\frac{\sum_{i=1}^{N_c}\tilde{w}_i(x)c_i^{dct}}{\sum_{i=1}^{N_c}\tilde{w}_i(x)}
+\frac{1}{\sigma^2}y
\Bigg)
$$
\pagebreak
\section*{6.3 Visualization}
\subsection*{6.3.1 K-Means approximation}
The task was to compare the KDE of the DCT coefficients for the whole image pack (e.g. the true KDE) with the approximation via K-Means. The true KDE reults were given as a dataset, the KDE of the approximation was to be computed for the approximation with $N_c=500$ and patchsize $p=2$.
As the k-means data was also given, we just run the KDE on the K-Means data with the required parameters.\\
\\
A fitting bandwidth $H$ was to be found for minimizing the difference between the true and the approximated KDE.  In figure \ref{fig:6.3.1:1}, the visualization of the true KDE compared to the K-Means approximation for different bandwidths $h$ is shown. The comparison is only shown for the marginalization of the first dimension, as the selection of a suitable badwith can be done in one dimension. We chose a $h$ of $0.04$, as it seems to be the best fit. For a greater $h$, the approximation seems to miss some details from the true KDE, while a smaller $h$ results in a way to steep behavior.\\
\\
\begin{figure}[H]
	\centering
	\begin{subfigure}{.5\textwidth}
		\centering
		\includegraphics[width=.9\linewidth]{../imgs/ref/Task6_3_reference_marg0_3D.png}
		\caption{True KDE}
	\end{subfigure}\\
	\begin{subfigure}{\textwidth}
		\begin{subfigure}{.3\textwidth}
			\centering
			\includegraphics[width=1.2\linewidth]{{../imgs/Task6_3_km_h0_03_marg0_3D}.png}
			\subcaption{$h=0.03$}
			%\label{fig:4a_sc}
		\end{subfigure}%
		\begin{subfigure}{.3\textwidth}
			\centering
			\includegraphics[width=1.2\linewidth]{{../imgs/Task6_3_km_h0_04_marg0_3D}.png}
			\subcaption{$h=0.04$}
			%\label{fig:4a_sc}
		\end{subfigure}%
		\begin{subfigure}{.3\textwidth}
			\centering
			\includegraphics[width=1.2\linewidth]{{../imgs/Task6_3_km_h0_05_marg0_3D}.png}
			\subcaption{$h=0.05$}
			%\label{fig:4a_sc}
		\end{subfigure}%	
		\caption*{KDE K-Means Approximation}
	\end{subfigure}	
	\caption{Comparison of true KDE and K-Means approximation with marginalized first dimension for different bandwidths}
	\label{fig:6.3.1:1}
\end{figure}%
Afterwards we visualized the true KDE and the approximation for each dimension marginalized. Figure \ref{fig:6.3.1:2} shows the resulting plots.
As one can observe, the shape of the KDE is quite similar, apart from some details that are not perfectly reproduced by the approximation. One thing that stands out is the scaling that seems not to match the true KDE. This could be a normalization issue, that only influences the scaling but not the shape itself.

\begin{figure}[H]
	\centering
	\begin{subfigure}{\textwidth}
		\begin{subfigure}{.3\textwidth}
			\centering
			\includegraphics[width=1.2\linewidth]{{../imgs/ref/Task6_3_reference_marg0_3D}.png}
			\subcaption{Marginalized Dim 1}
			%\label{fig:4a_sc}
		\end{subfigure}%
		\begin{subfigure}{.3\textwidth}
			\centering
			\includegraphics[width=1.2\linewidth]{{../imgs/ref/Task6_3_reference_marg1_3D}.png}
			\subcaption{Marginalized Dim 2}
			%\label{fig:4a_sc}
		\end{subfigure}%
		\begin{subfigure}{.3\textwidth}
			\centering
			\includegraphics[width=1.2\linewidth]{{../imgs/ref/Task6_3_reference_marg2_3D}.png}
			\subcaption{Marginalized Dim 3}
			%\label{fig:4a_sc}
		\end{subfigure}%	
		\caption*{True KDE}
	\end{subfigure}	\\
	\begin{subfigure}{\textwidth}
		\begin{subfigure}{.3\textwidth}
			\centering
			\includegraphics[width=1.2\linewidth]{{../imgs/Task6_3_km_h0_04_marg0_3D}.png}
			\subcaption{Marginalized Dim 1}
			%\label{fig:4a_sc}
		\end{subfigure}%
		\begin{subfigure}{.3\textwidth}
			\centering
			\includegraphics[width=1.2\linewidth]{{../imgs/Task6_3_km_h0_04_marg1_3D}.png}
			\subcaption{Marginalized Dim 2}
			%\label{fig:4a_sc}
		\end{subfigure}%
		\begin{subfigure}{.3\textwidth}
			\centering
			\includegraphics[width=1.2\linewidth]{{../imgs/Task6_3_km_h0_04_marg2_3D}.png}
			\subcaption{Marginalized Dim 3}
			%\label{fig:4a_sc}
		\end{subfigure}%	
		\caption*{KDE K-Means Approximation}
	\end{subfigure}	
	\caption{Comparison of true KDE and K-Means approximation for each marginalized dimension}
	\label{fig:6.3.1:2}
\end{figure}

\subsection*{6.3.2 K-Means approximation}
For visualization and discussing the performance of the approximation, different plots were to be generated. The plots were done for a bandwidth $h=0.04$, as this gave the best performance in the task before. Furthermore, the approximation was done for a patchsize $p=2$ and a number of centers $N_c=1000$.\\
\\
As a first visualizing, the resulting image at different iterations was plotted in Figure \ref{fig:6.3.2:1}, where the three images represent the estimated, the reference and the noisy image (from left to right). As one can see, the estimate is not completely denoised after the last iteration, but compared to the earlier iterations there is a significant improvement. The poor performance could be improved if the algorithm were to be run with higher number of centers or bigger patchsize, which unfortunately was not possible on our machines.\\
\begin{figure}[H]
	\centering
		\begin{subfigure}{\textwidth}
			\centering
			\includegraphics[trim=0 100 0 100, clip, width=\linewidth]{{../imgs/Iter1}.png}
			\subcaption{Iteration 1}
			%\label{fig:4a_sc}
		\end{subfigure}\\
		\begin{subfigure}{\textwidth}
			\centering
			\includegraphics[trim=0 100 0 100, clip, width=\linewidth]{{../imgs/Iter5}.png}
			\subcaption{Iteration 5}
			%\label{fig:4a_sc}
		\end{subfigure}\\
		\begin{subfigure}{\textwidth}
			\centering
			\includegraphics[trim=0 100 0 100, clip, width=\linewidth]{{../imgs/Iter10}.png}
			\subcaption{Iteration 10}
			%\label{fig:4a_sc}
		\end{subfigure}\\	
	\caption{Approximation, Reference and Noisy Image at different iterations}
	\label{fig:6.3.2:1}
\end{figure}
The resulting PSNR value over the iterations of the algorithm is shown in Figure \ref{fig:6.3.2:2}. The final result for the PSNR was 26.43, a value that could again be improved with different parameterizing of the algorithm.\\
\begin{figure}[H]
	\centering
	\includegraphics[width=\linewidth]{{../imgs/psnr}.png}	
	\caption{PSNR over iterations}
	\label{fig:6.3.2:2}
\end{figure}
\begin{figure}[H]
	\centering
	\begin{subfigure}{\textwidth}
		\centering
		\includegraphics[width=\linewidth]{{../imgs/traj_h0_04}.png}
		\subcaption{Patches before averaging}
		%\label{fig:4a_sc}
	\end{subfigure}\\
	\begin{subfigure}{\textwidth}
		\centering
		\includegraphics[width=\linewidth]{{../imgs/traj_h0_04_avg}.png}
		\subcaption{Patches after averaging}
		%\label{fig:4a_sc}
	\end{subfigure}\\
	\caption{Trajectories of patches in DCT space before/after averaging over iterations}
	\label{fig:6.3.2:3}
\end{figure}
Finally, the trajectories of some patches in the DCT space over the iterations were to be plotted. In figure \ref{fig:6.3.2:3} the trajectories for the non-averaged and averaged patched are shown. As one can see, the movement never actually reaches the center. This is, besides of the maximum iterations, caused by the fact that the approximation algorithm does maximize the posterior and not the prior of the distribution.
\end{document}